/*
*** Kleines Utility zur Wandlung von Umlauten.
***
*** Dieses Programm darf frei kopiert werden. Die Weitergabe ist nur
*** unentgeldlich und zusammen mit diesem Source gestattet.
***
*** Spenden willkommen, aber nicht Bedingung:
***
*** Postgiroamt Hamburg
*** BLZ 20010020
*** Konto 541391-206
*** Stichwort 'TNX fer UMLAUT'
***
*** Axel Bauda, DG1BBQ @DB0CL.DEU.EU
*** Potsdamer Str.43
*** D-w2850 Bremerhaven 1
*** Germany
 */

/* Turbo C / Turbo C++ / Borland C++ */

#define DATUM "25.05.92"
#define VERSION "1.31"

#define EOS '\0'

#include <alloc.h>
#include <dir.h>
#include <dos.h>
#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dir.h>

char   ibm[]       = "IBM";
char   _7bt[]      = "7Bit";
char   iso8[]      = "ISO-8Bit";
char   _2char[]    = "Doppelzeichen";
char   uml_ibm[]   = "";
char   uml_7bt[]   = "{|}[\\]~";
char   uml_iso8[]  = "";
char   uml_2char[] = "aeoeueAeOeUesz";


/*
*** Copy a file.
***
***
 */
int copy_file (char *from, char *to)
{
  FILE *_from, *_to;
  int _char, stat;

  _from = fopen (from, "r");
  _to   = fopen (to, "w");

  while ((_char = getc (_from)) != EOF)
    if ((stat = putc (_char, _to)) == EOF)
      break;

  fclose (_from);
  fclose (_to);

  if (stat == EOF)
  {
    printf ("\007 Fataler Fehler. Kann '%s' nicht schreiben! Abbruch.\n", to);
    exit (2);
  }
  return (0);
}

/*
*** Main loop.
***
***
 */
int main (int argc, char **argv)
{
  struct ffblk entry;
  struct ftime ft;
  char   *tab[9][4]  = {  uml_ibm , uml_2char, ibm  , _2char,
                          uml_7bt , uml_2char, _7bt , _2char,
                          uml_iso8, uml_2char, iso8 , _2char,
                          uml_ibm , uml_7bt  , ibm  , _7bt  ,
                          uml_ibm , uml_iso8 , ibm  , iso8  ,
                          uml_7bt , uml_ibm  , _7bt , ibm   ,
                          uml_7bt , uml_iso8 , _7bt , iso8  ,
                          uml_iso8, uml_ibm  , iso8 , ibm   ,
                          uml_iso8, uml_7bt  , iso8 , _7bt    };
  char   test[2];
  char   first[81];
  char   inpath[81];
  char   current[81];
  char   tempfile[81];
  char   drive[MAXDRIVE];
  char   dir[MAXDIR];
  char   *q, *r, *s, *t, *u;
  FILE   *in, *out;
  int    next_one;
  int    letter;
  int    action;
  int    l, i;
  int    attrib;
  int    reset_arch;
  int    files;
  size_t buflen;

  *test = *first = *inpath = *current = *tempfile = EOS;
  *drive = *dir = EOS;
  q = r = s = t = u = NULL;
  i = action = attrib = reset_arch = files = 0;

  printf ("\nUMLAUT v"VERSION" - Utility zur Wandlung von Umlauten.\n");
  printf ("               Axel Bauda, DG1BBQ @DB0CL.DEU.EU, "DATUM"\n\n");

  l = -1;

  /* Parse through command line */
  while (++i < argc)
  {

    if (strstr (" -m -M ", argv[i]))
    {
      attrib = FA_ARCH;
      continue;
    }

    if (strstr (" -a -A ", argv[i]))
    {
      attrib = FA_ARCH;
      reset_arch = 1;
      continue;
    }

    if (strstr (" -s -S ", argv[i]))
    {
      uml_ibm[6] = '';
      continue;
    }

    /* Get filename from command line */
    if (!q && *argv[i] != '-')
      q = argv[i];

    if (*argv[i] == '-')
    {
      if (strstr (" -i2 ",     argv[i]))
        action = l = 1;
      if (strstr (" -72 ",     argv[i]))
        action = l = 2;
      if (strstr (" -82 ",     argv[i]))
        action = l = 3;
      if (strstr (" -i7 -I7 ", argv[i]))
        action = l = 4;
      if (strstr (" -i8 -I8 ", argv[i]))
        action = l = 5;
      if (strstr (" -7i -7I ", argv[i]))
        action = l = 6;
      if (strstr (" -78 ",     argv[i]))
        action = l = 7;
      if (strstr (" -8i -8I ", argv[i]))
        action = l = 8;
      if (strstr (" -87 ",     argv[i]))
        action = l = 9;

      if (l == -1)
      {
        q = argv[i];
        l = 0;
        break;
      }
    }
  }

  if (argc > 1)
  {
    if (!l)
      printf ("Unbekannte Option: '%s'\n", q);

    if (!action)
      printf ("Wandeloption fehlt!\n");

    if (!l || !action)
    {
      q = NULL;
      printf ("\n");
    }
  }

  if (!q)
  {
    printf ("Benutzung:\n\n");
    printf ("umlaut [Optionen] <Filename>\n\n");
    printf ("Optionen:   -i7  IBM  -> 7BIT  |  -i2  IBM  -> Doppelzeichen\n");
    printf ("            -i8  IBM  -> ISO8  |  -72  7BIT -> Doppelzeichen\n");
    printf ("            -8i  ISO8 -> IBM   |  -82  ISO8 -> Doppelzeichen\n");
    printf ("            -87  ISO8 -> 7BIT  |\n");
    printf ("            -7i  7BIT -> IBM   |\n");
    printf ("            -78  7BIT -> ISO8  |\n");
    printf ("            -s   (ATARI ST) '' statt ''.\n");
    printf ("            -m   Nur Dateien mit gesetztem Archiv-Bit bearbeiten.\n");
    printf ("            -a   Wie '-m', nur bleibt das Archiv-Bit gesetzt.\n\n");
    printf ("Die Verwendung von Ersatzzeichen (*.txt usw) ist erlaubt.\n\n");
    return (0);
  }

  strupr (q);

  fnsplit (q, drive,  dir, NULL, NULL);
  sprintf (inpath, "%s%s", drive, dir);

  r = getenv ("TEMP");
  if (r != NULL)
  {
    strcpy (tempfile, r);
    if (r[strlen (r) -1] != ':' && r[strlen (r) -1] != '\\')
      strcat (tempfile, "\\");
  }

  getcwd (first, MAXPATH);
  fnsplit (first, dir, NULL, NULL, NULL);

  if ((!strcmp (drive, dir) || !*drive) && *dir > 'B')
    sprintf (tempfile, "%s\\", drive);

  strcat (tempfile, "umlaut.$$$");

  *first = test[1] = EOS;

  buflen = coreleft ();
  buflen = (buflen -2000) /2;

  if (buflen > 32767)
    buflen = 32767;

  l = 1;
  if (action < 4)
    l = 2;

  s = tab[action-1][0];
  t = tab[action-1][1];

  printf ("%s- in %s-Umlaute wandeln (%s --> %s).\n\n",
                                    tab[action-1][2], tab[action-1][3], s, t);

  next_one = 1;

  in = NULL;
 
  do
  {
    if (in)
    {
      fclose (in);
      in = NULL;
    }

    if (next_one == 1)
    {
      next_one = findfirst (q, &entry, 0);
      if (!next_one)
      {
        sprintf (first, "%s%s", inpath, entry.ff_name);
        strcpy (current, first);
      }
    }
    else
    {
      next_one = findnext (&entry);
      if (!next_one && !strcmp (first, entry.ff_name))
        next_one = findnext (&entry);
      sprintf (current, "%s%s", inpath, entry.ff_name);
    }

    if (next_one || (!(entry.ff_attrib & attrib) && attrib))
      continue;

    files++;

    printf ("%-12s:", entry.ff_name);

    if (entry.ff_attrib & FA_RDONLY)
    {
      printf (" Datei ist schreibgeschtzt. Nicht gewandelt.\n");
      continue;
    }

    if (strstr (current, ".COM") || strstr (current, ".EXE"))
    {
      printf (" Nicht gewandelt.\n");
      continue;
    }
    if ((in = fopen (current, "r")) == NULL)
    {
      printf (" Fehler beim ffnen.\n");
      continue;
    }
    setvbuf (in, NULL, _IOFBF, buflen);

    getftime (fileno(in), &ft);

    if ((out = fopen (tempfile, "w")) == NULL)
    {
      printf (" Fehler beim Schreiben. Kann Temporrfile nicht anlegen!\n");
      continue;
    }
    setvbuf (out, NULL, _IOFBF, buflen);

    while ((letter = getc (in)) != EOF)
    {
      test[0] = (char) letter;

      if ((u = strstr (s, test)) != NULL)
      {
        letter = (int) t[(u-s)*l];
        if (action < 4)
        {
          putc (letter, out);
          letter = (int) t[((u-s)*l)+1];
        }
      }
      putc (letter, out);
    }

    fclose (in);
    in = NULL;

    if (fclose (out))
    {
      printf (" Fehler beim Schreiben.\n");
      continue;
    }

    if (unlink (current))
    {
      printf (" Kann Ursprungsdatei nicht lschen. Nicht gewandelt.\n");
      unlink (tempfile);
      continue;
    }

    if (rename (tempfile, current))
    {
      copy_file (tempfile, current);
      unlink (tempfile);
    }

    out = fopen (current, "r+");
    setftime (fileno(out), &ft);
    fclose (out);
    if (!reset_arch)
      _chmod (current, 1, 0);

    printf (" OK.\n");
  }
  while (!next_one);

  if (!files)
    printf ("Keine Files gefunden....\n");

  if (in)
    fclose (in);

  return (0);
}
